<?php
/*
Plugin Name: Google+1
Version: auto
Description: Add a "+1" Google button
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=562
Author: Mistic
Author URI: http://www.strangeplanet.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('GPLUS1_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

load_language('plugin.lang', GPLUS1_PATH);
add_event_handler('loc_end_picture', 'gplus1_add_button');
add_event_handler('loc_end_index', 'gplus1_add_button');


function gplus1_add_button() 
{
  global $conf, $template, $user;
  
  $conf['GooglePlusOne'] = explode(',', $conf['GooglePlusOne']);
  $conf['GooglePlusOne']['lang'] = array(
    'ar','bg','ca','hr','cs','da','nl','et','fi','fr','de','el','iw','hi',
    'hu','id','it','ja','ko','lv','lt','ms','no','fa','pl','ro','ru','sr',
    'sk','sl','es','sv','th','tr','uk','vi'
    );
  
  if (script_basename() == 'picture')
  {
    $template->assign(array(
      'GPLUS1_SIZE' => $conf['GooglePlusOne'][0],
      'GPLUS1_POSITON' => $conf['GooglePlusOne'][1],
    ));
        
    $template->set_prefilter('picture', 'gplus1_add_button_prefilter');
  }
  else if (script_basename() == 'index')
  {
    $template->assign(array(
      'GPLUS1_SIZE' => $conf['GooglePlusOne'][0],
      'GPLUS1_POSITON' => 'index',
    ));
        
    $template->set_prefilter('index', 'gplus1_add_button_prefilter');
  }
  
  // if the link is in the toolbar, we must use smallier buttons
  if ( script_basename() == 'index' OR  $conf['GooglePlusOne'][1] == 'toolbar')
  {
    if ($conf['GooglePlusOne'][0] == 'tall')
    {
        $template->assign('GPLUS1_SIZE', 'standard');
    }
  }
  
  // button language
  if ( in_array(substr($user['language'],0,2), $conf['GooglePlusOne']['lang']) )
  {
    $template->assign('GPLUS1_LANG', substr($user['language'],0,2));
  }
  else
  {
    $template->assign('GPLUS1_LANG', 'en-GB');
  }
}

function gplus1_add_button_prefilter($content, &$smarty)
{
  global $template;
  
  switch ($template->get_template_vars('GPLUS1_POSITON'))
  {
    case 'top':
      $search = '<div id="theImage">';
      $replace = '<div><g:plusone size="{$GPLUS1_SIZE}"></g:plusone></div>';
      break;
      
    case 'bottom':
      $search = '{$ELEMENT_CONTENT}';
      $replace = '<g:plusone size="{$GPLUS1_SIZE}"></g:plusone>';
      break;
      
    case 'toolbar':
      $search = '{*caddie management END*}';
      $replace = '<g:plusone size="{$GPLUS1_SIZE}"></g:plusone>';
      break;
      
    case 'index':  
      $search = '<ul class="categoryActions">';
      $replace = '<li><g:plusone size="{$GPLUS1_SIZE}"></g:plusone></li>';
      break;
  }
  $replace = $search.$replace.'
{combine_script id=\'google_plusone\' path=\'https://apis.google.com/js/plusone.js\'}
<script type="text/javascript">{ldelim}lang: \'{$GPLUS1_LANG}\'}</script>';

  return str_replace($search, $replace, $content);
}


if (script_basename() == 'admin')
{
  add_event_handler('get_admin_plugin_menu_links', 'gplus1_plugin_admin_menu');

  function gplus1_plugin_admin_menu($menu)
  {
    array_push(
      $menu,
      array(
        'NAME' => 'Google+1',
        'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
        )
      );
    
    return $menu;
  }
}

?>